#include <console/loglevel.h>

#if CONFIG_USE_PRINTK_IN_CAR == 0
static void __console_tx_byte(unsigned char byte)
{
	uart_tx_byte(byte);
#if CONFIG_USBDEBUG_DIRECT
	usbdebug_direct_tx_byte(byte);
#endif
}
#if CONFIG_USBDEBUG_DIRECT
static void __console_ram_tx_byte(unsigned char byte)
{
	uart_tx_byte(byte);
	usbdebug_direct_ram_tx_byte(byte);
}
#endif

#include "console_print.c"
#include "console_print_ram.c"

#else /* CONFIG_USE_PRINTK_IN_CAR == 1 */ 

#include "console_printk.c"
#include "console_printk_ram.c"

// do_printk
#include "../../../console/vtxprintf.c"
#include "printk_init.c"

#endif

#include "console_ram.c" 

#ifndef LINUXBIOS_EXTRA_VERSION
#define LINUXBIOS_EXTRA_VERSION ""
#endif


static void console_init(void)
{
	static const char console_test[] = 
		"\r\n\r\nLinuxBIOS-"
		LINUXBIOS_VERSION
		LINUXBIOS_EXTRA_VERSION
		" "
		LINUXBIOS_BUILD
		" starting...\r\n";
	print_info(console_test);
}


static void die(const char *str)
{
	print_emerg(str);
	do {
		hlt();
	} while(1);
}
