#if CONFIG_USBDEBUG_DIRECT

extern int do_printk_ram(int msg_level, const char *fmt, ...);

#define printk_ram_emerg(fmt, arg...)   do_printk_ram(BIOS_EMERG   ,fmt, ##arg)
#define printk_ram_alert(fmt, arg...)   do_printk_ram(BIOS_ALERT   ,fmt, ##arg)
#define printk_ram_crit(fmt, arg...)    do_printk_ram(BIOS_CRIT    ,fmt, ##arg)
#define printk_ram_err(fmt, arg...)     do_printk_ram(BIOS_ERR     ,fmt, ##arg)
#define printk_ram_warning(fmt, arg...) do_printk_ram(BIOS_WARNING ,fmt, ##arg)
#define printk_ram_notice(fmt, arg...)  do_printk_ram(BIOS_NOTICE  ,fmt, ##arg)
#define printk_ram_info(fmt, arg...)    do_printk_ram(BIOS_INFO    ,fmt, ##arg)
#define printk_ram_debug(fmt, arg...)   do_printk_ram(BIOS_DEBUG   ,fmt, ##arg)
#define printk_ram_spew(fmt, arg...)    do_printk_ram(BIOS_SPEW    ,fmt, ##arg)

#else

#define printk_ram_emerg(fmt, arg...)   do_printk(BIOS_EMERG   ,fmt, ##arg)
#define printk_ram_alert(fmt, arg...)   do_printk(BIOS_ALERT   ,fmt, ##arg)
#define printk_ram_crit(fmt, arg...)    do_printk(BIOS_CRIT    ,fmt, ##arg)
#define printk_ram_err(fmt, arg...)     do_printk(BIOS_ERR     ,fmt, ##arg)
#define printk_ram_warning(fmt, arg...) do_printk(BIOS_WARNING ,fmt, ##arg)
#define printk_ram_notice(fmt, arg...)  do_printk(BIOS_NOTICE  ,fmt, ##arg)
#define printk_ram_info(fmt, arg...)    do_printk(BIOS_INFO    ,fmt, ##arg)
#define printk_ram_debug(fmt, arg...)   do_printk(BIOS_DEBUG   ,fmt, ##arg)
#define printk_ram_spew(fmt, arg...)    do_printk(BIOS_SPEW    ,fmt, ##arg)

#endif


#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_EMERG
#undef  printk_ram_emerg
#define printk_ram_emerg(fmt, arg...)   do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ALERT
#undef  printk_ram_alert
#define printk_ram_alert(fmt, arg...)   do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_CRIT
#undef  printk_ram_crit
#define printk_ram_crit(fmt, arg...)    do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_ERR
#undef  printk_ram_err
#define printk_ram_err(fmt, arg...)     do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_WARNING
#undef  printk_ram_warning
#define printk_ram_warning(fmt, arg...) do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_NOTICE
#undef  printk_ram_notice
#define printk_ram_notice(fmt, arg...)  do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_INFO
#undef  printk_ram_info
#define printk_ram_info(fmt, arg...)    do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_DEBUG
#undef  printk_ram_debug
#define printk_ram_debug(fmt, arg...)   do {} while(0)
#endif
#if MAXIMUM_CONSOLE_LOGLEVEL <= BIOS_SPEW
#undef  printk_ram_spew
#define printk_ram_spew(fmt, arg...)    do {} while(0)
#endif

#if CONFIG_USBDEBUG_DIRECT

#define print_ram_emerg(STR)   printk_ram_emerg  ("%s", (STR))
#define print_ram_alert(STR)   printk_ram_alert  ("%s", (STR))
#define print_ram_crit(STR)    printk_ram_crit   ("%s", (STR))
#define print_ram_err(STR)     printk_ram_err    ("%s", (STR))
#define print_ram_warning(STR) printk_ram_warning("%s", (STR))
#define print_ram_notice(STR)  printk_ram_notice ("%s", (STR))
#define print_ram_info(STR)    printk_ram_info   ("%s", (STR))
#define print_ram_debug(STR)   printk_ram_debug  ("%s", (STR))
#define print_ram_spew(STR)    printk_ram_spew   ("%s", (STR))

#define print_ram_emerg_char(CH)   printk_ram_emerg  ("%c", (CH))
#define print_ram_alert_char(CH)   printk_ram_alert  ("%c", (CH))
#define print_ram_crit_char(CH)    printk_ram_crit   ("%c", (CH))
#define print_ram_err_char(CH)     printk_ram_err    ("%c", (CH))
#define print_ram_warning_char(CH) printk_ram_warning("%c", (CH))
#define print_ram_notice_char(CH)  printk_ram_notice ("%c", (CH))
#define print_ram_info_char(CH)    printk_ram_info   ("%c", (CH))
#define print_ram_debug_char(CH)   printk_ram_debug  ("%c", (CH))
#define print_ram_spew_char(CH)    printk_ram_spew   ("%c", (CH))

#define print_ram_emerg_hex8(HEX)   printk_ram_emerg  ("%02x",  (HEX))
#define print_ram_alert_hex8(HEX)   printk_ram_alert  ("%02x",  (HEX))
#define print_ram_crit_hex8(HEX)    printk_ram_crit   ("%02x",  (HEX))
#define print_ram_err_hex8(HEX)     printk_ram_err    ("%02x",  (HEX))
#define print_ram_warning_hex8(HEX) printk_ram_warning("%02x",  (HEX))
#define print_ram_notice_hex8(HEX)  printk_ram_notice ("%02x",  (HEX))
#define print_ram_info_hex8(HEX)    printk_ram_info   ("%02x",  (HEX))
#define print_ram_debug_hex8(HEX)   printk_ram_debug  ("%02x",  (HEX))
#define print_ram_spew_hex8(HEX)    printk_ram_spew   ("%02x",  (HEX))

#define print_ram_emerg_hex16(HEX)   printk_ram_emerg  ("%04x", (HEX))
#define print_ram_alert_hex16(HEX)   printk_ram_alert  ("%04x", (HEX))
#define print_ram_crit_hex16(HEX)    printk_ram_crit   ("%04x", (HEX))
#define print_ram_err_hex16(HEX)     printk_ram_err    ("%04x", (HEX))
#define print_ram_warning_hex16(HEX) printk_ram_warning("%04x", (HEX))
#define print_ram_notice_hex16(HEX)  printk_ram_notice ("%04x", (HEX))
#define print_ram_info_hex16(HEX)    printk_ram_info   ("%04x", (HEX))
#define print_ram_debug_hex16(HEX)   printk_ram_debug  ("%04x", (HEX))
#define print_ram_spew_hex16(HEX)    printk_ram_spew   ("%04x", (HEX))

#define print_ram_emerg_hex32(HEX)   printk_ram_emerg  ("%08x", (HEX))
#define print_ram_alert_hex32(HEX)   printk_ram_alert  ("%08x", (HEX))
#define print_ram_crit_hex32(HEX)    printk_ram_crit   ("%08x", (HEX))
#define print_ram_err_hex32(HEX)     printk_ram_err    ("%08x", (HEX))
#define print_ram_warning_hex32(HEX) printk_ram_warning("%08x", (HEX))
#define print_ram_notice_hex32(HEX)  printk_ram_notice ("%08x", (HEX))
#define print_ram_info_hex32(HEX)    printk_ram_info   ("%08x", (HEX))
#define print_ram_debug_hex32(HEX)   printk_ram_debug  ("%08x", (HEX))
#define print_ram_spew_hex32(HEX)    printk_ram_spew   ("%08x", (HEX))

#endif

